Subject: Re: bug#76402: ‘guix-packages-website’ fails to start

From: Luis Felipe <[email-masked]>
Date: Tue, 25 Feb 2025 18:40:49 +0000

On 25/02/25 13:21, Ludovic Courtès wrote:
> [email-masked] skribis:
>
>> From: Luis Felipe <[email-masked]>
>>
>> * hydra/modules/sysadmin/services.scm (%guix-packages-website): Update
>> commit, version and hash accordingly.
>> (guix-packages-website-shepherd-services): Update file mappings in
>> the least authority wrapper. Namely, map "sys/i18n/json" (artanis now
>> requires it) and "lib" (the guile "gweb" library is now inside it).
> Applied and deployed, but it now fails with:
>
> --8<---------------cut here---------------start------------->8---
> 2025-02-25 14:19:31 Backtrace:
> 2025-02-25 14:19:31 In ice-9/boot-9.scm:
> 2025-02-25 14:19:31   1752:10 13 (with-exception-handler _ _ #:unwind? _ # _)
> 2025-02-25 14:19:31 In unknown file:
> 2025-02-25 14:19:31           12 (apply-smob/0 #<thunk 7fcfddadf300>)
> 2025-02-25 14:19:31 In ice-9/boot-9.scm:
> 2025-02-25 14:19:31     724:2 11 (call-with-prompt _ _ #<procedure default-prompt-handle…>)
> 2025-02-25 14:19:31 In ice-9/eval.scm:
> 2025-02-25 14:19:31     619:8 10 (_ #(#(#<directory (guile-user) 7fcfddae2c80>)))
> 2025-02-25 14:19:31 In /gnu/store/94bl7pzx14mrpap4jsdfvdwq0bj26xzn-artanis-1.2.2/bin/.art-real:
> 2025-02-25 14:19:31     48:12  9 (_ _ _)
> 2025-02-25 14:19:31 In artanis/commands/work.scm:
> 2025-02-25 14:19:31     145:8  8 (work . _)
> 2025-02-25 14:19:31 In ice-9/boot-9.scm:
> 2025-02-25 14:19:31    2836:4  7 (save-module-excursion #<procedure 7fcfd34a8b70 at ice-…>)
> 2025-02-25 14:19:31   4388:12  6 (_)
> 2025-02-25 14:19:31   3983:14  5 (_)
> 2025-02-25 14:19:31   3935:20  4 (process-use-modules _)
> 2025-02-25 14:19:31    222:29  3 (map1 (((artanis artanis)) ((gweb builders) # build:) #))
> 2025-02-25 14:19:31    222:17  2 (map1 (((gweb builders) #:prefix build:) ((artanis #))))
> 2025-02-25 14:19:31   3936:31  1 (_ ((gweb builders) #:prefix build:))
> 2025-02-25 14:19:31    3330:6  0 (resolve-interface (gweb builders) #:select _ #:hide _ # …)
> 2025-02-25 14:19:31
> 2025-02-25 14:19:31 ice-9/boot-9.scm:3330:6: In procedure resolve-interface:
> 2025-02-25 14:19:31 no code for module (gweb builders)
> --8<---------------cut here---------------end--------------->8---
>
> Any ideas?

Well, in version 0.4.0 of the packages website the «gweb» library was 
moved to the «lib» directory, which is supposed to be added to Guile 
load path automatically 
(https://codeberg.org/luis-felipe/guix-packages-website/src/branch/master/ENTRY#L10).

But I don't understand why the instance in bayfront fails to find (gweb 
builders). I just tried the patched service again in a virtual machine 
and it works as expected:

+ 
https://luis-felipe.gitlab.io/media/2025/02/guix-packages-website-service-status-2025-02-25.png
+ 
https://luis-felipe.gitlab.io/media/2025/02/guix-packages-website-service-in-browser-2025-02-25.png

I create and run the virtual machine like this:

   $ guix system vm -L ~/Projects/maintenance/hydra/modules 
preproduction-gnome-os.scm
   $ /gnu/store/HASH-run-vm.sh -nic user,model=virtio-net-pci -m 2000M

Where «preproduction-gnome-os.scm» is the OS defined in 
https://codeberg.org/luis-felipe/guix-packages-website/issues/20.

So maybe my testing process is not reliable (?). I can't reproduce the 
error...